;--------------------------------------------------------
; File Created by SLCC : free open source ANSI-C Compiler
; Version 3.6.0 #Jan 18 2022 (MSVC)
;--------------------------------------------------------
; SL port for the RISC core
;--------------------------------------------------------
;	.file	"F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\4_XC8P9525_WDT\XC8P9520-WDT.C"
	list	p=XC8P9525
	radix dec
	include "XC8P9525.inc"
;--------------------------------------------------------
; external declarations
;--------------------------------------------------------
	extern	_delayUs
	extern	_delayMs
	extern	_IARbits
	extern	_TCCbits
	extern	_PCLbits
	extern	_STATUSbits
	extern	_RSRbits
	extern	_PORT6bits
	extern	_PWMCONbits
	extern	_PRDbits
	extern	_PDC1bits
	extern	_PDC2bits
	extern	_PDC3bits
	extern	_ICIECRbits
	extern	_CPUCONbits
	extern	_ISRbits
	extern	_IAR
	extern	_TCC
	extern	_PCL
	extern	_STATUS
	extern	_RSR
	extern	_PORT6
	extern	_PWMCON
	extern	_PRD
	extern	_PDC1
	extern	_PDC2
	extern	_PDC3
	extern	_ICIECR
	extern	_CPUCON
	extern	_ISR
;--------------------------------------------------------
; global declarations
;--------------------------------------------------------
	global	_file_WDTWake_slep
	global	_file_WDTTime
	global	_file_project_init
	global	_file_init
	global	_file_clrRam
	global	_main
	global	_int_isr
	global	_A_BUFF
	global	_R3_BUFF
	global	_reg_sleep_cnt

	global STK11
	global STK10
	global STK09
	global STK08
	global STK07
	global STK06
	global STK05
	global STK04
	global STK03
	global STK02
	global STK01
	global STK00

sharebank udata_ovr 0x0020
STK11	res 1
STK10	res 1
STK09	res 1
STK08	res 1
STK07	res 1
STK06	res 1
STK05	res 1
STK04	res 1
STK03	res 1
STK02	res 1
STK01	res 1
STK00	res 1

;--------------------------------------------------------
; global definitions
;--------------------------------------------------------
UD_XC8P9520_WDT_0	udata
_reg_sleep_cnt	res	1

;--------------------------------------------------------
; absolute symbol definitions
;--------------------------------------------------------
UD_abs_XC8P9520_WDT_10	udata_ovr	0x0010
_A_BUFF
	res	1
UD_abs_XC8P9520_WDT_11	udata_ovr	0x0011
_R3_BUFF
	res	1
;--------------------------------------------------------
; compiler-defined variables
;--------------------------------------------------------
UDL_XC8P9520_WDT_0	udata
r0x1001	res	1
r0x1003	res	1
;--------------------------------------------------------
; initialized data
;--------------------------------------------------------

;@Allocation info for local variables in function 'main'
;@main file_clrRam               Allocated to registers ;size:2
;@main file_init                 Allocated to registers ;size:2
;@main file_WDTTime              Allocated to registers ;size:2
;@main file_project_init         Allocated to registers ;size:2
;@main file_WDTWake_slep         Allocated to registers ;size:2
;@main delayUs                   Allocated to registers ;size:2
;@main delayMs                   Allocated to registers ;size:2
;@main main                      Allocated to registers ;size:2
;@main IARbits                   Allocated to registers ;size:1
;@main TCCbits                   Allocated to registers ;size:1
;@main PCLbits                   Allocated to registers ;size:1
;@main STATUSbits                Allocated to registers ;size:1
;@main RSRbits                   Allocated to registers ;size:1
;@main PORT6bits                 Allocated to registers ;size:1
;@main PWMCONbits                Allocated to registers ;size:1
;@main PRDbits                   Allocated to registers ;size:1
;@main PDC1bits                  Allocated to registers ;size:1
;@main PDC2bits                  Allocated to registers ;size:1
;@main PDC3bits                  Allocated to registers ;size:1
;@main ICIECRbits                Allocated to registers ;size:1
;@main CPUCONbits                Allocated to registers ;size:1
;@main ISRbits                   Allocated to registers ;size:1
;@main A_BUFF                    Allocated to registers ;size:1
;@main R3_BUFF                   Allocated to registers ;size:1
;@main reg_sleep_cnt             Allocated to registers ;size:1
;@main IAR                       Allocated to registers ;size:1
;@main TCC                       Allocated to registers ;size:1
;@main PCL                       Allocated to registers ;size:1
;@main STATUS                    Allocated to registers ;size:1
;@main RSR                       Allocated to registers ;size:1
;@main PORT6                     Allocated to registers ;size:1
;@main PWMCON                    Allocated to registers ;size:1
;@main PRD                       Allocated to registers ;size:1
;@main PDC1                      Allocated to registers ;size:1
;@main PDC2                      Allocated to registers ;size:1
;@main PDC3                      Allocated to registers ;size:1
;@main ICIECR                    Allocated to registers ;size:1
;@main CPUCON                    Allocated to registers ;size:1
;@main ISR                       Allocated to registers ;size:1
;@end Allocation info for local variables in function 'main';

;--------------------------------------------------------
; overlayable items in internal ram 
;--------------------------------------------------------
;	udata_ovr
;--------------------------------------------------------
; reset vector 
;--------------------------------------------------------
STARTUP	code 0x0000
	jmp	_main
;--------------------------------------------------------
; interrupt and initialization code
;--------------------------------------------------------
c_interrupt	code	0x0003
__sdcc_interrupt:
;***
;  pBlock Stats: dbName = I
;***
;2 compiler assigned registers:
;   r0x1003
;   r0x1004
;; Starting pCode block
_int_isr:	;Function start
; 0 exit points
;	.line	163; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\4_XC8P9525_WDT\XC8P9520-WDT.C	__asm__("org 0x08");			//жڵַ			
	org	0x08
;	.line	164; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\4_XC8P9525_WDT\XC8P9520-WDT.C	PUSH(_A_BUFF,_R3_BUFF);			//жջ
	mov	_A_BUFF,a
	swap	_A_BUFF
	swapa	STATUS
	mov	_R3_BUFF,a
;	.line	166; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\4_XC8P9525_WDT\XC8P9520-WDT.C	if(TCIF)						//жTCIFǷΪ1
	JBTS	_ISRbits,0
	JMP	_00140_DS_
;	.line	168; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\4_XC8P9525_WDT\XC8P9520-WDT.C	TCC	  += 0x06;				//1/2 * 8 * (256-6) = 1000us	ʽ1/IRCƵ * ԤƵ * 256-ֵ
	MOV	A,@0x06
	ADD	_TCC,A
;	.line	169; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\4_XC8P9525_WDT\XC8P9520-WDT.C	ISR    = 0xfe;				//TC0жϱ־λ
	MOV	A,@0xfe
	MOV	_ISR,A
;	.line	170; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\4_XC8P9525_WDT\XC8P9520-WDT.C	io_ledOut = !io_ledOut;		//P61ڷת
	CLR	r0x1003
	JBTC	_PORT6bits,1
	INC	r0x1003
	MOV	A,r0x1003
	MOV	A,@0x00
	JBTC	STATUS,2
	MOV	A,@0x01
	MOV	r0x1003,A
;;1	MOV	r0x1004,A
;;100	MOV	A,r0x1004
	RCA	r0x1003
	JBTS	STATUS,0
	BTC	_PORT6bits,1
	JBTC	STATUS,0
	BTS	_PORT6bits,1
_00140_DS_:
;	.line	173; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\4_XC8P9525_WDT\XC8P9520-WDT.C	POP(_A_BUFF,_R3_BUFF);			//жϳջָ
	swapa	_R3_BUFF
	mov	STATUS,a
	swapa	_A_BUFF
;	.line	174; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\4_XC8P9525_WDT\XC8P9520-WDT.C	}
END_OF_INTERRUPT:
	RETI	

;--------------------------------------------------------
; code
;--------------------------------------------------------
code_XC8P9520_WDT	code
;***
;  pBlock Stats: dbName = M
;***
;has an exit
;functions called:
;   _file_clrRam
;   _file_init
;   _file_WDTTime
;   _file_WDTWake_slep
;   _file_clrRam
;   _file_init
;   _file_WDTTime
;   _file_WDTWake_slep
;; Starting pCode block
S_XC8P9520_WDT__main	code
_main:	;Function start
; 2 exit points
;	.line	40; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\4_XC8P9525_WDT\XC8P9520-WDT.C	if(T)
	JBTS	_STATUSbits,4
	JMP	_00106_DS_
;	.line	42; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\4_XC8P9525_WDT\XC8P9520-WDT.C	file_clrRam();				//ϵ縴λ֮WDTλ
	CALL	_file_clrRam
_00106_DS_:
;	.line	44; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\4_XC8P9525_WDT\XC8P9520-WDT.C	file_init();					//ioĴʼ
	CALL	_file_init
;	.line	46; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\4_XC8P9525_WDT\XC8P9520-WDT.C	EI();							//ж
	ei	
_00108_DS_:
;	.line	50; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\4_XC8P9525_WDT\XC8P9520-WDT.C	file_WDTTime();				//WDTʱ
	CALL	_file_WDTTime
;	.line	51; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\4_XC8P9525_WDT\XC8P9520-WDT.C	file_WDTWake_slep();		//WDT˯
	CALL	_file_WDTWake_slep
;	.line	52; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\4_XC8P9525_WDT\XC8P9520-WDT.C	NOP();
	nop	
;	.line	53; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\4_XC8P9525_WDT\XC8P9520-WDT.C	NOP();
	nop	
;	.line	54; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\4_XC8P9525_WDT\XC8P9520-WDT.C	NOP();
	nop	
	JMP	_00108_DS_
;	.line	56; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\4_XC8P9525_WDT\XC8P9520-WDT.C	}
	RET	
; exit point of _main

;***
;  pBlock Stats: dbName = C
;***
;has an exit
;; Starting pCode block
S_XC8P9520_WDT__file_WDTWake_slep	code
_file_WDTWake_slep:	;Function start
; 2 exit points
;	.line	113; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\4_XC8P9525_WDT\XC8P9520-WDT.C	IOCP_W(WDTCR,0x00);		 //ƵTCCлҪȹWDT 
	mov	a,@0x00
	iw	WDTCR
;	.line	115; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\4_XC8P9525_WDT\XC8P9520-WDT.C	IOCP_W(IMR,0x00);
	mov	a,@0x00
	iw	IMR
;	.line	116; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\4_XC8P9525_WDT\XC8P9520-WDT.C	ISR=0;
	CLR	_ISR
;	.line	117; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\4_XC8P9525_WDT\XC8P9520-WDT.C	CWDT();
	CWDT	
;	.line	118; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\4_XC8P9525_WDT\XC8P9520-WDT.C	CONTW(0x09);			//ԤƵָwdt,2Ƶ 
	mov	a,@0x09
	ctw
;	.line	119; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\4_XC8P9525_WDT\XC8P9520-WDT.C	IOCP_W(WDTCR,0x80);
	mov	a,@0x80
	iw	WDTCR
;	.line	120; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\4_XC8P9525_WDT\XC8P9520-WDT.C	DI();
	di	
;	.line	121; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\4_XC8P9525_WDT\XC8P9520-WDT.C	NOP();
	nop	
;	.line	122; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\4_XC8P9525_WDT\XC8P9520-WDT.C	SLEEP();
	sleep	
;	.line	123; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\4_XC8P9525_WDT\XC8P9520-WDT.C	NOP();
	nop	
;	.line	124; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\4_XC8P9525_WDT\XC8P9520-WDT.C	NOP();
	nop	
;	.line	125; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\4_XC8P9525_WDT\XC8P9520-WDT.C	}
	RET	
; exit point of _file_WDTWake_slep

;***
;  pBlock Stats: dbName = C
;***
;has an exit
;2 compiler assigned registers:
;   r0x1001
;   r0x1002
;; Starting pCode block
S_XC8P9520_WDT__file_WDTTime	code
_file_WDTTime:	;Function start
; 2 exit points
;	.line	101; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\4_XC8P9525_WDT\XC8P9520-WDT.C	if(++reg_sleep_cnt>=10) // 
	INC	_reg_sleep_cnt
	MOV	A,@0x0a
	SUB	A,_reg_sleep_cnt
	JBTS	STATUS,0
	JMP	_00130_DS_
;	.line	103; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\4_XC8P9525_WDT\XC8P9520-WDT.C	reg_sleep_cnt=0;
	CLR	_reg_sleep_cnt
;	.line	104; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\4_XC8P9525_WDT\XC8P9520-WDT.C	io_led2Out = !io_led2Out;			//P62ڷת
	CLR	r0x1001
	JBTC	_PORT6bits,2
	INC	r0x1001
	MOV	A,r0x1001
	MOV	A,@0x00
	JBTC	STATUS,2
	MOV	A,@0x01
	MOV	r0x1001,A
;;1	MOV	r0x1002,A
;;99	MOV	A,r0x1002
	RCA	r0x1001
	JBTS	STATUS,0
	BTC	_PORT6bits,2
	JBTC	STATUS,0
	BTS	_PORT6bits,2
;	.line	106; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\4_XC8P9525_WDT\XC8P9520-WDT.C	}
_00130_DS_:
	RET	
; exit point of _file_WDTTime

;***
;  pBlock Stats: dbName = C
;***
;has an exit
;; Starting pCode block
S_XC8P9520_WDT__file_project_init	code
_file_project_init:	;Function start
; 2 exit points
;	.line	93; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\4_XC8P9525_WDT\XC8P9520-WDT.C	}
;	.line	93; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\4_XC8P9525_WDT\XC8P9520-WDT.C	}
	RET	
; exit point of _file_project_init

;***
;  pBlock Stats: dbName = C
;***
;has an exit
;; Starting pCode block
S_XC8P9520_WDT__file_init	code
_file_init:	;Function start
; 2 exit points
;	.line	74; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\4_XC8P9525_WDT\XC8P9520-WDT.C	CONTW(0x02);			//TCC 8Ƶ
	mov	a,@0x02
	ctw
;	.line	75; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\4_XC8P9525_WDT\XC8P9520-WDT.C	TCC = data_tcc;			//1/2 * 8 * (256-6) = 1000us	ʽ1/IRCƵ * ԤƵ * 256-ֵ
	MOV	A,@0x06
	MOV	_TCC,A
;	.line	76; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\4_XC8P9525_WDT\XC8P9520-WDT.C	PORT6 = 0;				//P6
	CLR	_PORT6
;	.line	77; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\4_XC8P9525_WDT\XC8P9520-WDT.C	IOCP_W(P6CR,0x08);		//P6Ϊ
	mov	a,@0x08
	iw	P6CR
;	.line	78; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\4_XC8P9525_WDT\XC8P9520-WDT.C	IOCP_W(ODCR,0x00);		//P6ڹؿ©
	mov	a,@0x00
	iw	ODCR
;	.line	79; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\4_XC8P9525_WDT\XC8P9520-WDT.C	IOCP_W(PHDCR,0xff);		//˿ƼĴbit7-bit4ӦP67-P64;bit3-bit0ӦP53-P50 
	mov	a,@0xff
	iw	PHDCR
;	.line	80; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\4_XC8P9525_WDT\XC8P9520-WDT.C	IOCP_W(PDCR,0xff);		//˿ƼĴ  bit6-bit4ӦP62-P60,bit3-bit0ӦP53-P50
	mov	a,@0xff
	iw	PDCR
;	.line	81; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\4_XC8P9525_WDT\XC8P9520-WDT.C	IOCP_W(PHCR,0xff);		//P6˿ƼĴ  bit7-bit0ӦP67-P60
	mov	a,@0xff
	iw	PHCR
;	.line	82; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\4_XC8P9525_WDT\XC8P9520-WDT.C	IOCP_W(WDTCR,0x00);		//WDT ʹܿƼĴ
	mov	a,@0x00
	iw	WDTCR
;	.line	83; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\4_XC8P9525_WDT\XC8P9520-WDT.C	IOCP_W(IMR,0x01);		//жʹܿƼĴ 
	mov	a,@0x01
	iw	IMR
;	.line	84; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\4_XC8P9525_WDT\XC8P9520-WDT.C	ISR = 0x0;				//TC0жϱ־λ 
	CLR	_ISR
;	.line	85; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\4_XC8P9525_WDT\XC8P9520-WDT.C	}
	RET	
; exit point of _file_init

;***
;  pBlock Stats: dbName = C
;***
;has an exit
;; Starting pCode block
S_XC8P9520_WDT__file_clrRam	code
_file_clrRam:	;Function start
; 2 exit points
;	.line	63; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\4_XC8P9525_WDT\XC8P9520-WDT.C	for(RSR=0x90;RSR<0xFF;RSR++)	// BANK0 RAM  IAR-R0,RSR-R4
	MOV	A,@0x90
	MOV	_RSR,A
_00115_DS_:
	MOV	A,@0xff
	SUB	A,_RSR
	JBTC	STATUS,0
	JMP	_00113_DS_
;	.line	65; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\4_XC8P9525_WDT\XC8P9520-WDT.C	{IAR = 0;}
	CLR	_IAR
;	.line	63; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\4_XC8P9525_WDT\XC8P9520-WDT.C	for(RSR=0x90;RSR<0xFF;RSR++)	// BANK0 RAM  IAR-R0,RSR-R4
	INC	_RSR
	JMP	_00115_DS_
_00113_DS_:
;	.line	66; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\4_XC8P9525_WDT\XC8P9520-WDT.C	IAR = 0;
	CLR	_IAR
;	.line	67; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\4_XC8P9525_WDT\XC8P9520-WDT.C	}
	RET	
; exit point of _file_clrRam


;	code size estimation:
;	   67+    0 =    67 instructions (  134 byte)

	end
