;--------------------------------------------------------
; File Created by SLCC : free open source ANSI-C Compiler
; Version 3.6.0 #Jan 18 2022 (MSVC)
;--------------------------------------------------------
; SL port for the RISC core
;--------------------------------------------------------
;	.file	"D:\\¼¼ļ\¼ļ\2022\2209\0914\XC8P9525_DEMO_C\2_XC8P9525_RTCж\XC8P9525-RTC.C"
	list	p=XC8P9525
	radix dec
	include "XC8P9525.inc"
;--------------------------------------------------------
; external declarations
;--------------------------------------------------------
	extern	_IARbits
	extern	_TCCbits
	extern	_PCLbits
	extern	_STATUSbits
	extern	_RSRbits
	extern	_PORT6bits
	extern	_PWMCONbits
	extern	_PRDbits
	extern	_PDC1bits
	extern	_PDC2bits
	extern	_PDC3bits
	extern	_ICIECRbits
	extern	_CPUCONbits
	extern	_ISRbits
	extern	_IAR
	extern	_TCC
	extern	_PCL
	extern	_STATUS
	extern	_RSR
	extern	_PORT6
	extern	_PWMCON
	extern	_PRD
	extern	_PDC1
	extern	_PDC2
	extern	_PDC3
	extern	_ICIECR
	extern	_CPUCON
	extern	_ISR
;--------------------------------------------------------
; global declarations
;--------------------------------------------------------
	global	_file_project_init
	global	_file_init
	global	_file_clrRam
	global	_main
	global	_int_isr
	global	_A_BUFF
	global	_R3_BUFF

	global STK11
	global STK10
	global STK09
	global STK08
	global STK07
	global STK06
	global STK05
	global STK04
	global STK03
	global STK02
	global STK01
	global STK00

sharebank udata_ovr 0x0020
STK11	res 1
STK10	res 1
STK09	res 1
STK08	res 1
STK07	res 1
STK06	res 1
STK05	res 1
STK04	res 1
STK03	res 1
STK02	res 1
STK01	res 1
STK00	res 1

;--------------------------------------------------------
; global definitions
;--------------------------------------------------------
;--------------------------------------------------------
; absolute symbol definitions
;--------------------------------------------------------
UD_abs_XC8P9525_RTC_10	udata_ovr	0x0010
_A_BUFF
	res	1
UD_abs_XC8P9525_RTC_11	udata_ovr	0x0011
_R3_BUFF
	res	1
;--------------------------------------------------------
; compiler-defined variables
;--------------------------------------------------------
UDL_XC8P9525_RTC_0	udata
r0x1000	res	1
;--------------------------------------------------------
; initialized data
;--------------------------------------------------------

;@Allocation info for local variables in function 'main'
;@main file_clrRam               Allocated to registers ;size:2
;@main file_init                 Allocated to registers ;size:2
;@main file_project_init         Allocated to registers ;size:2
;@main main                      Allocated to registers ;size:2
;@main IARbits                   Allocated to registers ;size:1
;@main TCCbits                   Allocated to registers ;size:1
;@main PCLbits                   Allocated to registers ;size:1
;@main STATUSbits                Allocated to registers ;size:1
;@main RSRbits                   Allocated to registers ;size:1
;@main PORT6bits                 Allocated to registers ;size:1
;@main PWMCONbits                Allocated to registers ;size:1
;@main PRDbits                   Allocated to registers ;size:1
;@main PDC1bits                  Allocated to registers ;size:1
;@main PDC2bits                  Allocated to registers ;size:1
;@main PDC3bits                  Allocated to registers ;size:1
;@main ICIECRbits                Allocated to registers ;size:1
;@main CPUCONbits                Allocated to registers ;size:1
;@main ISRbits                   Allocated to registers ;size:1
;@main A_BUFF                    Allocated to registers ;size:1
;@main R3_BUFF                   Allocated to registers ;size:1
;@main IAR                       Allocated to registers ;size:1
;@main TCC                       Allocated to registers ;size:1
;@main PCL                       Allocated to registers ;size:1
;@main STATUS                    Allocated to registers ;size:1
;@main RSR                       Allocated to registers ;size:1
;@main PORT6                     Allocated to registers ;size:1
;@main PWMCON                    Allocated to registers ;size:1
;@main PRD                       Allocated to registers ;size:1
;@main PDC1                      Allocated to registers ;size:1
;@main PDC2                      Allocated to registers ;size:1
;@main PDC3                      Allocated to registers ;size:1
;@main ICIECR                    Allocated to registers ;size:1
;@main CPUCON                    Allocated to registers ;size:1
;@main ISR                       Allocated to registers ;size:1
;@end Allocation info for local variables in function 'main';

;--------------------------------------------------------
; overlayable items in internal ram 
;--------------------------------------------------------
;	udata_ovr
;--------------------------------------------------------
; reset vector 
;--------------------------------------------------------
STARTUP	code 0x0000
	jmp	_main
;--------------------------------------------------------
; interrupt and initialization code
;--------------------------------------------------------
c_interrupt	code	0x0003
__sdcc_interrupt:
;***
;  pBlock Stats: dbName = I
;***
;2 compiler assigned registers:
;   r0x1000
;   r0x1001
;; Starting pCode block
_int_isr:	;Function start
; 0 exit points
;	.line	93; D:\\¼¼ļ\¼ļ\2022\2209\0914\XC8P9525_DEMO_C\2_XC8P9525_RTCж\XC8P9525-RTC.C	__asm__("org 0x08");			//жڵַ			
	org	0x08
;	.line	94; D:\\¼¼ļ\¼ļ\2022\2209\0914\XC8P9525_DEMO_C\2_XC8P9525_RTCж\XC8P9525-RTC.C	PUSH(_A_BUFF,_R3_BUFF);			//жջ
	mov	_A_BUFF,a
	swap	_A_BUFF
	swapa	STATUS
	mov	_R3_BUFF,a
;	.line	96; D:\\¼¼ļ\¼ļ\2022\2209\0914\XC8P9525_DEMO_C\2_XC8P9525_RTCж\XC8P9525-RTC.C	if(TCIF)						//жTCIFǷΪ1
	JBTS	_ISRbits,0
	JMP	_00127_DS_
;	.line	98; D:\\¼¼ļ\¼ļ\2022\2209\0914\XC8P9525_DEMO_C\2_XC8P9525_RTCж\XC8P9525-RTC.C	ISR    = 0xfe;				//TC0жϱ־λ
	MOV	A,@0xfe
	MOV	_ISR,A
;	.line	99; D:\\¼¼ļ\¼ļ\2022\2209\0914\XC8P9525_DEMO_C\2_XC8P9525_RTCж\XC8P9525-RTC.C	PORT6_1 = !PORT6_1;			//P61ڷת
	CLR	r0x1000
	JBTC	_PORT6bits,1
	INC	r0x1000
	MOV	A,r0x1000
	MOV	A,@0x00
	JBTC	STATUS,2
	MOV	A,@0x01
	MOV	r0x1000,A
;;1	MOV	r0x1001,A
;;99	MOV	A,r0x1001
	RCA	r0x1000
	JBTS	STATUS,0
	BTC	_PORT6bits,1
	JBTC	STATUS,0
	BTS	_PORT6bits,1
_00127_DS_:
;	.line	102; D:\\¼¼ļ\¼ļ\2022\2209\0914\XC8P9525_DEMO_C\2_XC8P9525_RTCж\XC8P9525-RTC.C	POP(_A_BUFF,_R3_BUFF);			//жϳջָ
	swapa	_R3_BUFF
	mov	STATUS,a
	swapa	_A_BUFF
;	.line	103; D:\\¼¼ļ\¼ļ\2022\2209\0914\XC8P9525_DEMO_C\2_XC8P9525_RTCж\XC8P9525-RTC.C	}
END_OF_INTERRUPT:
	RETI	

;--------------------------------------------------------
; code
;--------------------------------------------------------
code_XC8P9525_RTC	code
;***
;  pBlock Stats: dbName = M
;***
;has an exit
;functions called:
;   _file_clrRam
;   _file_init
;   _file_project_init
;   _file_clrRam
;   _file_init
;   _file_project_init
;; Starting pCode block
S_XC8P9525_RTC__main	code
_main:	;Function start
; 2 exit points
;	.line	32; D:\\¼¼ļ\¼ļ\2022\2209\0914\XC8P9525_DEMO_C\2_XC8P9525_RTCж\XC8P9525-RTC.C	file_clrRam();					//RAM
	CALL	_file_clrRam
;	.line	33; D:\\¼¼ļ\¼ļ\2022\2209\0914\XC8P9525_DEMO_C\2_XC8P9525_RTCж\XC8P9525-RTC.C	file_init();					//ioĴʼ
	CALL	_file_init
;	.line	34; D:\\¼¼ļ\¼ļ\2022\2209\0914\XC8P9525_DEMO_C\2_XC8P9525_RTCж\XC8P9525-RTC.C	file_project_init();			//蹦
	CALL	_file_project_init
;	.line	35; D:\\¼¼ļ\¼ļ\2022\2209\0914\XC8P9525_DEMO_C\2_XC8P9525_RTCж\XC8P9525-RTC.C	EI();							//ж
	ei	
_00106_DS_:
;	.line	39; D:\\¼¼ļ\¼ļ\2022\2209\0914\XC8P9525_DEMO_C\2_XC8P9525_RTCж\XC8P9525-RTC.C	NOP();
	nop	
;	.line	40; D:\\¼¼ļ\¼ļ\2022\2209\0914\XC8P9525_DEMO_C\2_XC8P9525_RTCж\XC8P9525-RTC.C	NOP();
	nop	
;	.line	41; D:\\¼¼ļ\¼ļ\2022\2209\0914\XC8P9525_DEMO_C\2_XC8P9525_RTCж\XC8P9525-RTC.C	NOP();
	nop	
	JMP	_00106_DS_
;	.line	43; D:\\¼¼ļ\¼ļ\2022\2209\0914\XC8P9525_DEMO_C\2_XC8P9525_RTCж\XC8P9525-RTC.C	}
	RET	
; exit point of _main

;***
;  pBlock Stats: dbName = C
;***
;has an exit
;; Starting pCode block
S_XC8P9525_RTC__file_project_init	code
_file_project_init:	;Function start
; 2 exit points
;	.line	87; D:\\¼¼ļ\¼ļ\2022\2209\0914\XC8P9525_DEMO_C\2_XC8P9525_RTCж\XC8P9525-RTC.C	}
;	.line	87; D:\\¼¼ļ\¼ļ\2022\2209\0914\XC8P9525_DEMO_C\2_XC8P9525_RTCж\XC8P9525-RTC.C	}
	RET	
; exit point of _file_project_init

;***
;  pBlock Stats: dbName = C
;***
;has an exit
;; Starting pCode block
S_XC8P9525_RTC__file_init	code
_file_init:	;Function start
; 2 exit points
;	.line	61; D:\\¼¼ļ\¼ļ\2022\2209\0914\XC8P9525_DEMO_C\2_XC8P9525_RTCж\XC8P9525-RTC.C	CONTW(0x84);			//TCC 32Ƶ,RTC
	mov	a,@0x84
	ctw
;	.line	62; D:\\¼¼ļ\¼ļ\2022\2209\0914\XC8P9525_DEMO_C\2_XC8P9525_RTCж\XC8P9525-RTC.C	TCC = 0;				//ʱжT = (1/32.768KHz)*4Clock*32*256 = 1S 
	CLR	_TCC
;	.line	63; D:\\¼¼ļ\¼ļ\2022\2209\0914\XC8P9525_DEMO_C\2_XC8P9525_RTCж\XC8P9525-RTC.C	PORT6 = 0;				//P6
	CLR	_PORT6
;	.line	64; D:\\¼¼ļ\¼ļ\2022\2209\0914\XC8P9525_DEMO_C\2_XC8P9525_RTCж\XC8P9525-RTC.C	IOCP_W(P6CR,0x00);		//P6Ϊ
	mov	a,@0x00
	iw	P6CR
;	.line	65; D:\\¼¼ļ\¼ļ\2022\2209\0914\XC8P9525_DEMO_C\2_XC8P9525_RTCж\XC8P9525-RTC.C	IOCP_W(ODCR,0x00);		//P6ڹؿ©
	mov	a,@0x00
	iw	ODCR
;	.line	66; D:\\¼¼ļ\¼ļ\2022\2209\0914\XC8P9525_DEMO_C\2_XC8P9525_RTCж\XC8P9525-RTC.C	IOCP_W(PHDCR,0xff);		//˿ƼĴbit7-bit4ӦP67-P64;bit3-bit0ӦP53-P50 
	mov	a,@0xff
	iw	PHDCR
;	.line	67; D:\\¼¼ļ\¼ļ\2022\2209\0914\XC8P9525_DEMO_C\2_XC8P9525_RTCж\XC8P9525-RTC.C	IOCP_W(PDCR,0xff);		//˿ƼĴ  bit6-bit4ӦP62-P60,bit3-bit0ӦP53-P50
	mov	a,@0xff
	iw	PDCR
;	.line	68; D:\\¼¼ļ\¼ļ\2022\2209\0914\XC8P9525_DEMO_C\2_XC8P9525_RTCж\XC8P9525-RTC.C	IOCP_W(PHCR,0xff);		//P6˿ƼĴ  bit7-bit0ӦP67-P60
	mov	a,@0xff
	iw	PHCR
;	.line	69; D:\\¼¼ļ\¼ļ\2022\2209\0914\XC8P9525_DEMO_C\2_XC8P9525_RTCж\XC8P9525-RTC.C	IOCP_W(WDTCR,0x00);		//WDT ʹܿƼĴ
	mov	a,@0x00
	iw	WDTCR
;	.line	70; D:\\¼¼ļ\¼ļ\2022\2209\0914\XC8P9525_DEMO_C\2_XC8P9525_RTCж\XC8P9525-RTC.C	IOCP_W(IMR,0x01);		//жʹܿƼĴ 
	mov	a,@0x01
	iw	IMR
;	.line	71; D:\\¼¼ļ\¼ļ\2022\2209\0914\XC8P9525_DEMO_C\2_XC8P9525_RTCж\XC8P9525-RTC.C	ISR = 0x0;				//TC0жϱ־λ 
	CLR	_ISR
;	.line	72; D:\\¼¼ļ\¼ļ\2022\2209\0914\XC8P9525_DEMO_C\2_XC8P9525_RTCж\XC8P9525-RTC.C	}
	RET	
; exit point of _file_init

;***
;  pBlock Stats: dbName = C
;***
;has an exit
;; Starting pCode block
S_XC8P9525_RTC__file_clrRam	code
_file_clrRam:	;Function start
; 2 exit points
;	.line	50; D:\\¼¼ļ\¼ļ\2022\2209\0914\XC8P9525_DEMO_C\2_XC8P9525_RTCж\XC8P9525-RTC.C	for(RSR=0x90;RSR<0xFF;RSR++)	// BANK0 RAM  IAR-R0,RSR-R4
	MOV	A,@0x90
	MOV	_RSR,A
_00113_DS_:
	MOV	A,@0xff
	SUB	A,_RSR
	JBTC	STATUS,0
	JMP	_00111_DS_
;	.line	52; D:\\¼¼ļ\¼ļ\2022\2209\0914\XC8P9525_DEMO_C\2_XC8P9525_RTCж\XC8P9525-RTC.C	{IAR = 0;}
	CLR	_IAR
;	.line	50; D:\\¼¼ļ\¼ļ\2022\2209\0914\XC8P9525_DEMO_C\2_XC8P9525_RTCж\XC8P9525-RTC.C	for(RSR=0x90;RSR<0xFF;RSR++)	// BANK0 RAM  IAR-R0,RSR-R4
	INC	_RSR
	JMP	_00113_DS_
_00111_DS_:
;	.line	53; D:\\¼¼ļ\¼ļ\2022\2209\0914\XC8P9525_DEMO_C\2_XC8P9525_RTCж\XC8P9525-RTC.C	IAR = 0;
	CLR	_IAR
;	.line	54; D:\\¼¼ļ\¼ļ\2022\2209\0914\XC8P9525_DEMO_C\2_XC8P9525_RTCж\XC8P9525-RTC.C	}
	RET	
; exit point of _file_clrRam


;	code size estimation:
;	   39+    0 =    39 instructions (   78 byte)

	end
