;--------------------------------------------------------
; File Created by SLCC : free open source ANSI-C Compiler
; Version 3.6.0 #Jan 18 2022 (MSVC)
;--------------------------------------------------------
; SL port for the RISC core
;--------------------------------------------------------
;	.file	"F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\6_XC8P9525_ģж\XC8P9525-INTERRUPT.C"
	list	p=XC8P9525
	radix dec
	include "XC8P9525.inc"
;--------------------------------------------------------
; external declarations
;--------------------------------------------------------
	extern	_IARbits
	extern	_TCCbits
	extern	_PCLbits
	extern	_STATUSbits
	extern	_RSRbits
	extern	_PORT6bits
	extern	_PWMCONbits
	extern	_PRDbits
	extern	_PDC1bits
	extern	_PDC2bits
	extern	_PDC3bits
	extern	_ICIECRbits
	extern	_CPUCONbits
	extern	_ISRbits
	extern	_IAR
	extern	_TCC
	extern	_PCL
	extern	_STATUS
	extern	_RSR
	extern	_PORT6
	extern	_PWMCON
	extern	_PRD
	extern	_PDC1
	extern	_PDC2
	extern	_PDC3
	extern	_ICIECR
	extern	_CPUCON
	extern	_ISR
;--------------------------------------------------------
; global declarations
;--------------------------------------------------------
	global	_file_pwmInt_set
	global	_file_p6Ic_set
	global	_file_project_init
	global	_file_init
	global	_file_clrRam
	global	_main
	global	_int_isr
	global	_A_BUFF
	global	_R3_BUFF
	global	_reg_sleep_cnt

	global STK11
	global STK10
	global STK09
	global STK08
	global STK07
	global STK06
	global STK05
	global STK04
	global STK03
	global STK02
	global STK01
	global STK00

sharebank udata_ovr 0x0020
STK11	res 1
STK10	res 1
STK09	res 1
STK08	res 1
STK07	res 1
STK06	res 1
STK05	res 1
STK04	res 1
STK03	res 1
STK02	res 1
STK01	res 1
STK00	res 1

;--------------------------------------------------------
; global definitions
;--------------------------------------------------------
UD_XC8P9525_INTERRUPT_0	udata
_reg_sleep_cnt	res	1

;--------------------------------------------------------
; absolute symbol definitions
;--------------------------------------------------------
UD_abs_XC8P9525_INTERRUPT_10	udata_ovr	0x0010
_A_BUFF
	res	1
UD_abs_XC8P9525_INTERRUPT_11	udata_ovr	0x0011
_R3_BUFF
	res	1
;--------------------------------------------------------
; compiler-defined variables
;--------------------------------------------------------
UDL_XC8P9525_INTERRUPT_0	udata
r0x1000	res	1
r0x1001	res	1
;--------------------------------------------------------
; initialized data
;--------------------------------------------------------

;@Allocation info for local variables in function 'main'
;@main file_clrRam               Allocated to registers ;size:2
;@main file_project_init         Allocated to registers ;size:2
;@main file_init                 Allocated to registers ;size:2
;@main file_p6Ic_set             Allocated to registers ;size:2
;@main file_pwmInt_set           Allocated to registers ;size:2
;@main main                      Allocated to registers ;size:2
;@main IARbits                   Allocated to registers ;size:1
;@main TCCbits                   Allocated to registers ;size:1
;@main PCLbits                   Allocated to registers ;size:1
;@main STATUSbits                Allocated to registers ;size:1
;@main RSRbits                   Allocated to registers ;size:1
;@main PORT6bits                 Allocated to registers ;size:1
;@main PWMCONbits                Allocated to registers ;size:1
;@main PRDbits                   Allocated to registers ;size:1
;@main PDC1bits                  Allocated to registers ;size:1
;@main PDC2bits                  Allocated to registers ;size:1
;@main PDC3bits                  Allocated to registers ;size:1
;@main ICIECRbits                Allocated to registers ;size:1
;@main CPUCONbits                Allocated to registers ;size:1
;@main ISRbits                   Allocated to registers ;size:1
;@main A_BUFF                    Allocated to registers ;size:1
;@main R3_BUFF                   Allocated to registers ;size:1
;@main reg_sleep_cnt             Allocated to registers ;size:1
;@main IAR                       Allocated to registers ;size:1
;@main TCC                       Allocated to registers ;size:1
;@main PCL                       Allocated to registers ;size:1
;@main STATUS                    Allocated to registers ;size:1
;@main RSR                       Allocated to registers ;size:1
;@main PORT6                     Allocated to registers ;size:1
;@main PWMCON                    Allocated to registers ;size:1
;@main PRD                       Allocated to registers ;size:1
;@main PDC1                      Allocated to registers ;size:1
;@main PDC2                      Allocated to registers ;size:1
;@main PDC3                      Allocated to registers ;size:1
;@main ICIECR                    Allocated to registers ;size:1
;@main CPUCON                    Allocated to registers ;size:1
;@main ISR                       Allocated to registers ;size:1
;@end Allocation info for local variables in function 'main';

;--------------------------------------------------------
; overlayable items in internal ram 
;--------------------------------------------------------
;	udata_ovr
;--------------------------------------------------------
; reset vector 
;--------------------------------------------------------
STARTUP	code 0x0000
	jmp	_main
;--------------------------------------------------------
; interrupt and initialization code
;--------------------------------------------------------
c_interrupt	code	0x0003
__sdcc_interrupt:
;***
;  pBlock Stats: dbName = I
;***
;2 compiler assigned registers:
;   r0x1000
;   r0x1001
;; Starting pCode block
_int_isr:	;Function start
; 0 exit points
;	.line	106; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\6_XC8P9525_ģж\XC8P9525-INTERRUPT.C	__asm__("org 0x08");			//жڵַ			
	org	0x08
;	.line	107; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\6_XC8P9525_ģж\XC8P9525-INTERRUPT.C	PUSH(_A_BUFF,_R3_BUFF);			//жջ
	mov	_A_BUFF,a
	swap	_A_BUFF
	swapa	STATUS
	mov	_R3_BUFF,a
;	.line	109; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\6_XC8P9525_ģж\XC8P9525-INTERRUPT.C	if(TCIF)					//жTCIFǷΪ1
	JBTS	_ISRbits,0
	JMP	_00135_DS_
;	.line	111; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\6_XC8P9525_ģж\XC8P9525-INTERRUPT.C	TCC	  += 0x06;				//1/2 * 8 * (256-6) = 1000us	ʽ1/IRCƵ * ԤƵ * 256-ֵ
	MOV	A,@0x06
	ADD	_TCC,A
;	.line	112; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\6_XC8P9525_ģж\XC8P9525-INTERRUPT.C	ISR    = 0xfe;				//TC0жϱ־λ
	MOV	A,@0xfe
	MOV	_ISR,A
;	.line	113; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\6_XC8P9525_ģж\XC8P9525-INTERRUPT.C	io_ledOut = !io_ledOut;			//P61ڷת
	CLR	r0x1000
	JBTC	_PORT6bits,1
	INC	r0x1000
	MOV	A,r0x1000
	MOV	A,@0x00
	JBTC	STATUS,2
	MOV	A,@0x01
	MOV	r0x1000,A
	MOV	r0x1001,A
;;102	MOV	A,r0x1001
	RCA	r0x1000
	JBTS	STATUS,0
	BTC	_PORT6bits,1
	JBTC	STATUS,0
	BTS	_PORT6bits,1
_00135_DS_:
;	.line	115; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\6_XC8P9525_ģж\XC8P9525-INTERRUPT.C	if(EXIF)					//жEXIFǷΪ1,ⲿж
	JBTS	_ISRbits,2
	JMP	_00137_DS_
;	.line	117; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\6_XC8P9525_ģж\XC8P9525-INTERRUPT.C	ISR    = 0xfb;				//EXIFжϱ־λ
	MOV	A,@0xfb
	MOV	_ISR,A
;	.line	118; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\6_XC8P9525_ģж\XC8P9525-INTERRUPT.C	PORT6_4 = !PORT6_4;			//P64ڷת
	CLR	r0x1000
	JBTC	_PORT6bits,4
	INC	r0x1000
	MOV	A,r0x1000
	MOV	A,@0x00
	JBTC	STATUS,2
	MOV	A,@0x01
	MOV	r0x1000,A
	MOV	r0x1001,A
;;101	MOV	A,r0x1001
	RCA	r0x1000
	JBTS	STATUS,0
	BTC	_PORT6bits,4
	JBTC	STATUS,0
	BTS	_PORT6bits,4
_00137_DS_:
;	.line	120; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\6_XC8P9525_ģж\XC8P9525-INTERRUPT.C	if(ICIF)					//жICIFǷΪ1,˿ڱ仯ж
	JBTS	_ISRbits,1
	JMP	_00139_DS_
;	.line	122; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\6_XC8P9525_ģж\XC8P9525-INTERRUPT.C	ISR    = 0xfd;				//ICIFжϱ־λ
	MOV	A,@0xfd
	MOV	_ISR,A
;	.line	123; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\6_XC8P9525_ģж\XC8P9525-INTERRUPT.C	PORT6_2 = !PORT6_2;			//P62ڷת
	CLR	r0x1000
	JBTC	_PORT6bits,2
	INC	r0x1000
	MOV	A,r0x1000
	MOV	A,@0x00
	JBTC	STATUS,2
	MOV	A,@0x01
	MOV	r0x1000,A
	MOV	r0x1001,A
;;100	MOV	A,r0x1001
	RCA	r0x1000
	JBTS	STATUS,0
	BTC	_PORT6bits,2
	JBTC	STATUS,0
	BTS	_PORT6bits,2
_00139_DS_:
;	.line	126; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\6_XC8P9525_ģж\XC8P9525-INTERRUPT.C	if(T1IF)					//жT1IFǷΪ1,pwmж
	JBTS	_ISRbits,3
	JMP	_00141_DS_
;	.line	128; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\6_XC8P9525_ģж\XC8P9525-INTERRUPT.C	ISR    = 0xf7;				//ISRbit3:T1IF
	MOV	A,@0xf7
	MOV	_ISR,A
;	.line	129; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\6_XC8P9525_ģж\XC8P9525-INTERRUPT.C	PORT6_5 = !PORT6_5;			//P65ڷת
	CLR	r0x1000
	JBTC	_PORT6bits,5
	INC	r0x1000
	MOV	A,r0x1000
	MOV	A,@0x00
	JBTC	STATUS,2
	MOV	A,@0x01
	MOV	r0x1000,A
	MOV	r0x1001,A
;;99	MOV	A,r0x1001
	RCA	r0x1000
	JBTS	STATUS,0
	BTC	_PORT6bits,5
	JBTC	STATUS,0
	BTS	_PORT6bits,5
_00141_DS_:
;	.line	132; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\6_XC8P9525_ģж\XC8P9525-INTERRUPT.C	POP(_A_BUFF,_R3_BUFF);			//жϳջָ
	swapa	_R3_BUFF
	mov	STATUS,a
	swapa	_A_BUFF
;	.line	133; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\6_XC8P9525_ģж\XC8P9525-INTERRUPT.C	}
END_OF_INTERRUPT:
	RETI	

;--------------------------------------------------------
; code
;--------------------------------------------------------
code_XC8P9525_INTERRUPT	code
;***
;  pBlock Stats: dbName = M
;***
;has an exit
;functions called:
;   _file_clrRam
;   _file_init
;   _file_p6Ic_set
;   _file_pwmInt_set
;   _file_project_init
;   _file_clrRam
;   _file_init
;   _file_p6Ic_set
;   _file_pwmInt_set
;   _file_project_init
;; Starting pCode block
S_XC8P9525_INTERRUPT__main	code
_main:	;Function start
; 2 exit points
;	.line	32; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\6_XC8P9525_ģж\XC8P9525-INTERRUPT.C	file_clrRam();					//RAM
	CALL	_file_clrRam
;	.line	33; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\6_XC8P9525_ģж\XC8P9525-INTERRUPT.C	file_init();					//ioĴʼ
	CALL	_file_init
;	.line	34; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\6_XC8P9525_ģж\XC8P9525-INTERRUPT.C	file_p6Ic_set();				//˿ڱ仯ж
	CALL	_file_p6Ic_set
;	.line	35; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\6_XC8P9525_ģж\XC8P9525-INTERRUPT.C	file_pwmInt_set();				//pwmж
	CALL	_file_pwmInt_set
;	.line	36; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\6_XC8P9525_ģж\XC8P9525-INTERRUPT.C	file_project_init();			//蹦
	CALL	_file_project_init
;	.line	37; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\6_XC8P9525_ģж\XC8P9525-INTERRUPT.C	EI();							//ж
	ei	
_00106_DS_:
;	.line	41; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\6_XC8P9525_ģж\XC8P9525-INTERRUPT.C	NOP();
	nop	
;	.line	42; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\6_XC8P9525_ģж\XC8P9525-INTERRUPT.C	NOP();
	nop	
;	.line	43; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\6_XC8P9525_ģж\XC8P9525-INTERRUPT.C	NOP();
	nop	
	JMP	_00106_DS_
;	.line	45; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\6_XC8P9525_ģж\XC8P9525-INTERRUPT.C	}
	RET	
; exit point of _main

;***
;  pBlock Stats: dbName = C
;***
;has an exit
;; Starting pCode block
S_XC8P9525_INTERRUPT__file_pwmInt_set	code
_file_pwmInt_set:	;Function start
; 2 exit points
;	.line	97; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\6_XC8P9525_ģж\XC8P9525-INTERRUPT.C	PWMCON = 0x88;			//pwm=1/8*2(Ƶ)*4clock*100=100us
	MOV	A,@0x88
	MOV	_PWMCON,A
;	.line	98; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\6_XC8P9525_ģж\XC8P9525-INTERRUPT.C	PRD = 100;				//PWMڼĴ
	MOV	A,@0x64
	MOV	_PRD,A
;	.line	99; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\6_XC8P9525_ģж\XC8P9525-INTERRUPT.C	}
	RET	
; exit point of _file_pwmInt_set

;***
;  pBlock Stats: dbName = C
;***
;has an exit
;; Starting pCode block
S_XC8P9525_INTERRUPT__file_p6Ic_set	code
_file_p6Ic_set:	;Function start
; 2 exit points
;	.line	90; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\6_XC8P9525_ģж\XC8P9525-INTERRUPT.C	ICIECR = 0x08;			//P63˿ڶ	
	MOV	A,@0x08
	MOV	_ICIECR,A
;	.line	91; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\6_XC8P9525_ģж\XC8P9525-INTERRUPT.C	}
	RET	
; exit point of _file_p6Ic_set

;***
;  pBlock Stats: dbName = C
;***
;has an exit
;; Starting pCode block
S_XC8P9525_INTERRUPT__file_project_init	code
_file_project_init:	;Function start
; 2 exit points
;	.line	80; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\6_XC8P9525_ģж\XC8P9525-INTERRUPT.C	IOCP_W(P6CR,0x09);		//P60
	mov	a,@0x09
	iw	P6CR
;	.line	81; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\6_XC8P9525_ģж\XC8P9525-INTERRUPT.C	IOCP_W(WDTCR,0x40);		//Bit<6>:EIS-P60 ⲿжʹλ,P60ΪжϽ
	mov	a,@0x40
	iw	WDTCR
;	.line	82; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\6_XC8P9525_ģж\XC8P9525-INTERRUPT.C	IOCP_W(IMR,0x0f);		//жʹܿƼĴ 
	mov	a,@0x0f
	iw	IMR
;	.line	83; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\6_XC8P9525_ģж\XC8P9525-INTERRUPT.C	ISR = 0x00;				//TC0жϱ־λ 
	CLR	_ISR
;	.line	84; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\6_XC8P9525_ģж\XC8P9525-INTERRUPT.C	}
	RET	
; exit point of _file_project_init

;***
;  pBlock Stats: dbName = C
;***
;has an exit
;; Starting pCode block
S_XC8P9525_INTERRUPT__file_init	code
_file_init:	;Function start
; 2 exit points
;	.line	60; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\6_XC8P9525_ģж\XC8P9525-INTERRUPT.C	CONTW(0x02);			//TCC 8Ƶ
	mov	a,@0x02
	ctw
;	.line	61; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\6_XC8P9525_ģж\XC8P9525-INTERRUPT.C	TCC = data_tcc;			//1/2 * 8 * (256-6) = 1000us	ʽ1/IRCƵ * ԤƵ * 256-ֵ
	MOV	A,@0x06
	MOV	_TCC,A
;	.line	62; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\6_XC8P9525_ģж\XC8P9525-INTERRUPT.C	PORT6 = 0;				//P6
	CLR	_PORT6
;	.line	63; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\6_XC8P9525_ģж\XC8P9525-INTERRUPT.C	IOCP_W(P6CR,0x09);		//P63
	mov	a,@0x09
	iw	P6CR
;	.line	64; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\6_XC8P9525_ģж\XC8P9525-INTERRUPT.C	IOCP_W(ODCR,0x00);		//P6ڹؿ©
	mov	a,@0x00
	iw	ODCR
;	.line	65; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\6_XC8P9525_ģж\XC8P9525-INTERRUPT.C	IOCP_W(PHDCR,0xff);		//˿ƼĴbit7-bit4ӦP67-P64;bit3-bit0ӦP53-P50 
	mov	a,@0xff
	iw	PHDCR
;	.line	66; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\6_XC8P9525_ģж\XC8P9525-INTERRUPT.C	IOCP_W(PDCR,0xff);		//˿ƼĴ  bit6-bit4ӦP62-P60,bit3-bit0ӦP53-P50
	mov	a,@0xff
	iw	PDCR
;	.line	67; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\6_XC8P9525_ģж\XC8P9525-INTERRUPT.C	IOCP_W(PHCR,0xf7);		//P6˿ƼĴ  bit7-bit0ӦP67-P60
	mov	a,@0xf7
	iw	PHCR
;	.line	68; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\6_XC8P9525_ģж\XC8P9525-INTERRUPT.C	IOCP_W(WDTCR,0x00);		//WDT ʹܿƼĴ
	mov	a,@0x00
	iw	WDTCR
;	.line	70; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\6_XC8P9525_ģж\XC8P9525-INTERRUPT.C	}
	RET	
; exit point of _file_init

;***
;  pBlock Stats: dbName = C
;***
;has an exit
;; Starting pCode block
S_XC8P9525_INTERRUPT__file_clrRam	code
_file_clrRam:	;Function start
; 2 exit points
;	.line	51; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\6_XC8P9525_ģж\XC8P9525-INTERRUPT.C	for(RSR=0x90;RSR<0xFF;RSR++)	// BANK0 RAM  IAR-R0,RSR-R4
	MOV	A,@0x90
	MOV	_RSR,A
_00113_DS_:
	MOV	A,@0xff
	SUB	A,_RSR
	JBTC	STATUS,0
	JMP	_00111_DS_
;	.line	52; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\6_XC8P9525_ģж\XC8P9525-INTERRUPT.C	{IAR = 0;}
	CLR	_IAR
;	.line	51; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\6_XC8P9525_ģж\XC8P9525-INTERRUPT.C	for(RSR=0x90;RSR<0xFF;RSR++)	// BANK0 RAM  IAR-R0,RSR-R4
	INC	_RSR
	JMP	_00113_DS_
_00111_DS_:
;	.line	53; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\6_XC8P9525_ģж\XC8P9525-INTERRUPT.C	IAR = 0;
	CLR	_IAR
;	.line	54; F:\123\DOME\XJ_XJ_C_DEMO\\XC8P9525_DEMO\XC8P9525_DEMO_C\6_XC8P9525_ģж\XC8P9525-INTERRUPT.C	}
	RET	
; exit point of _file_clrRam


;	code size estimation:
;	  107+    0 =   107 instructions (  214 byte)

	end
